<?php
/*******************************************************************************
	Filename				: ext.rh_form_attributes.php

	Created					: 20 May 2008
	Created by				: Rick Holmes/bhggraphicdesign.com

	Comments				: enables the addition of onsubmit, onreset and enctype
							  attributes to Expression Engine forms.
*******************************************************************************/	


if (!defined('EXT'))
{
    exit('Invalid file request');
}

class RH_form_attributes {
	
	var $settings		= array();
	var $ext_class		= 'RH_form_attributes';
	var $name			= 'Add Form Attributes';
	var $version		= '1.0.3';
	var $description	= "Enables onsubmit, onreset and enctype form attributes.<br />Also enables changing default id and action.";
	var $settings_exist = 'n';
	var $docs_url		= '';
	
	// available form attributes
	var $form_attrs			= array('id', 'action', 'class', 'onsubmit', 'onreset', 'enctype');
	
	// -----------------------------------
	// Constructor
	// -----------------------------------
	
	function RH_form_attributes($settings = '')
	{
		$this->settings = $settings;
	}


	// --------------------------------
	//  Activate Extension
	// --------------------------------
	
	function activate_extension()
	{
	    global $DB;
	    
	    $DB->query($DB->insert_string('exp_extensions',
	                                  array(
	                                        'extension_id' => '',
	                                        'class'        => "RH_form_attributes",
	                                        'method'       => "add_attributes",
	                                        'hook'         => "form_declaration_modify_data",
	                                        'settings'     => "",
	                                        'priority'     => 10,
	                                        'version'      => $this->version,
	                                        'enabled'      => "y"
	                                      )
	                                 )
	              );
	}

	
	// ----------------------------------
	// Update Extension
	// ----------------------------------
	
	function update_extension($current)
	{
		global $DB;
		
		if ($current == '' | $current == $this->version)
		{
			return FALSE;
		}

		if ($current < '1.0.3') {
			// update to next version 1.0.3
		}

		$DB->query("UPDATE exp_extensions 
                SET version = '".$DB->escape_str($this->version)."' 
                WHERE class = '".$this->ext_class."'");
	}
	
	// ---------------------------------
	// Disable Extension
	// ---------------------------------
				
	function disable_extension()
	{
		global $DB;
		
		$DB->query("DELETE FROM exp_extensions WHERE class = '" . $this->ext_class . "'");
	}

	// ------------------------------
	// Main method
	// ------------------------------
	
	function add_attributes($options)
	{
		global $TMPL, $EXT;
		
		// make it play nice with others
		if ($EXT->last_call !== FALSE)
		{
			$options = $EXT->last_call; 
		}

		if( !isset($TMPL)) return $options;
		
		// add attribute to form
		foreach ($this->form_attrs as $key=>$value)
		{
			if ($TMPL->fetch_param($value))
			{
				$options[$value] = $TMPL->fetch_param($value);
			}
		}
		
		return $options;
	}	

} // END CLASS

?>